;   "FreqMetr" (PIC16F628A).
;   -  ..
;uebe@newmail.ru

;  .
#define	INTG	PORTA,3	;- .
#define	SLE	PORTB,0	;   ( ).
#define	DAT	PORTB,1	;   , LCD.
#define	CLK	PORTB,2	;   , LCD.
#define	PWR	PORTB,4	;  .
#define	FIN	PORTB,6	;   TMR1.

;  .
CNTOFF1	equ	0x20	;  .
CNTOFF2	equ	0x21

CNT1	equ	0x22	; .
CNT2	equ	0x23
CNT3	equ	0x24

TEMP	equ	0x40	;   BinBcd.
COUNT	equ	0x41
BYTE3	equ	0x42
BYTE2	equ	0x43
BYTE1	equ	0x44
BYTE0	equ	0x45
BCD0	equ	0x46
BCD1	equ	0x47
BCD2	equ	0x48
BCD3	equ	0x49
BCD4	equ	0x4a
BCD5	equ	0x4b

IBUF	equ	0x60	; .

	list	p=16f628a
	#include p16f628a.inc
        __CONFIG _XT_OSC&_WDT_ON&_PWRTE_ON&_MCLRE_OFF&_BODEN_OFF&_LVP_OFF&_CP_OFF

;*****************************
;*               *
;*****************************
	ORG H'0000'
Start:	call	Ini
	goto	VoltM

;*****************************
;*           *
;*****************************
	ORG H'0004'
	; .
	retfie

;*****************************
;*           BODY            *
;*****************************
	ORG H'0030'
VoltM:	;  .
	movlw	.20
	movwf	CNT3
a00:	clrwdt
	clrf	BYTE3
	clrf	BYTE2
	clrf	BYTE1
	clrf	BYTE0
	bsf	STATUS,RP0	; .
	movlw	B'11110111'
	movwf	TRISA
        bcf	STATUS,RP0
	bcf	INTG
	call	Dly1
 	bsf	STATUS,RP0
	movlw	B'11111111'
	movwf	TRISA
        bcf	STATUS,RP0
	btfsc	CMCON,C1OUT	;.
	goto	$+.5
	incfsz	BYTE0,F
	goto	$+.2
	incf	BYTE1,F
	goto	$-.5
	call	BinBcd
	clrw			;    .
	movwf	IBUF
	movwf	IBUF+.1
	movwf	IBUF+.2
	movwf	IBUF+.7
	movwf	IBUF+.8
	movwf	IBUF+.9
	movlw	0x0f
	movwf	IBUF+.4
	movf	BCD4,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.3
	swapf	BCD5,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.5
	movf	BCD5,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.6
	call	RefDisp		;   LCD.
	call	Dly100		; 200ms.
	call	Dly100
	decfsz	CNT3,F
	goto	a00
	;   .
ChkOff:	clrwdt
	decfsz	CNTOFF1,F
	goto	AmpM
	decfsz	CNTOFF2,F
	goto	AmpM
	bcf	PWR		; .
	goto	$
	;  .
AmpM:	clrf	BYTE3
	clrf	BYTE2
	clrf	BYTE1
	clrf	BYTE0
	bsf	STATUS,RP0	; .
	movlw	B'11110111'
	movwf	TRISA
        bcf	STATUS,RP0
	bcf	INTG
	call	Dly1
 	bsf	STATUS,RP0
	movlw	B'11111111'
	movwf	TRISA
        bcf	STATUS,RP0
	btfsc	CMCON,C2OUT	;.
	goto	$+.5
	incfsz	BYTE0,F
	goto	$+.2
	incf	BYTE1,F
	goto	$-.5
	call	BinBcd
	movf	BCD4,W		; (999mV).
	andlw	0xf0
	btfsc	STATUS,Z
	goto	a20
	movlw	0x0b
	movwf	IBUF+.1
	clrw
	movwf	IBUF
	movwf	IBUF+.2
	goto	a30
a20:	movf	BCD4,W		;   LCD.
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF
	swapf	BCD5,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.1
	movf	BCD5,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.2
a30:	movlw	0x0f
	movwf	IBUF+.3
	;  .
FreqM:	clrf	BYTE3
	clrf	BYTE2
	clrf	BYTE1
	clrf	BYTE0
	clrf	TMR1H
	clrf	TMR1L
	bsf	T1CON,TMR1ON	; , 192ms (Ft=4MHz).
	movlw	.191
	movwf	CNT2
	call	Dly1
	btfsc	PIR1,TMR1IF
	incf	BYTE2,F
	bcf	PIR1,TMR1IF
	decfsz	CNT2,F
	goto	$-.5
	movlw	.14
	movwf	CNT2
	decfsz	CNT2,F
	goto	$-.1
	bcf	T1CON,TMR1ON	; .
	movf	TMR1L,W
	movwf	BYTE0
	movf	TMR1H,W
	movwf	BYTE1
	call	BinBcd
	swapf	BCD3,W		;   LCD.
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.4
	movf	BCD3,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.5
	swapf	BCD4,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.6
	movf	BCD4,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.7
	swapf	BCD5,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.8
	movf	BCD5,W
	andlw	0x0f
	btfsc	STATUS,Z
	movlw	0x0a
	movwf	IBUF+.9
	call	RefDisp		;   LCD.
	goto	ChkOff



;*****************************
;*               *
;*****************************
;  .
Ini:	movlw	B'00000000'	; ,  OPTION.
	movwf	PORTA
	movlw	B'00000001'
	movwf	PORTB
	bsf	STATUS,RP0
	movlw	B'11111111'
	movwf	TRISA
	movlw	B'11100000'
	movwf	TRISB
	movlw	B'10001111'
	movwf	OPTION_REG
	bcf	STATUS,RP0
	movlw	B'00000110'	; TMR1.
	movwf	T1CON
	movlw	B'00000011'	; .
	movwf	CMCON
	movlw	B'00000000'	; .
	movwf	INTCON
	bsf	PWR		;.
	clrf	CNTOFF1		;  .
	movlw	.5
	movwf	CNTOFF2
	call	IniSint		;  .
	return

;   (MB15E03sl).
	;    R-.
IniSint:bcf	SLE
	call	Out0
	call	Out1
	call	Out0
	call	Out1
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out1
	call	Out1
	call	Out1
	bsf	SLE
	; N-  A-.
	bcf	SLE
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out1
	call	Out1
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	call	Out0
	bsf	SLE
	return
Out0:	bcf	DAT		; -0.
	bsf	CLK
	bcf	CLK
	return
Out1:	bsf	DAT		; -1.
	bsf	CLK
	bcf	CLK
	return

;   HT1611(HT1613).
RefDisp:movlw	IBUF		;  
	movwf	FSR
z00:	bsf	CLK		;. ICLK & IDAT
	bsf	DAT
	btfss	INDF,3		; 1-  
	bcf	DAT		;  0 - 
	goto	$+.1
	bcf	CLK		;  
	goto	$+.1
	goto	$+.1
	bsf	CLK		;. ICLK & IDAT
	bsf	DAT
	btfss	INDF,2		; 2-  
	bcf	DAT		;  0 - 
	goto	$+.1
	bcf	CLK		;  
	goto	$+.1
	goto	$+.1
	bsf	CLK		;. ICLK & IDAT
	bsf	DAT
	btfss	INDF,1		; 3-  
	bcf	DAT		;  0 - 
	goto	$+.1
	bcf	CLK		;  
	goto	$+1
	goto	$+1
	bsf	CLK		;. ICLK & IDAT
	bsf	DAT
	btfss	INDF,0		; 4-  
	bcf	DAT		;  0 - 
	goto	$+.1
	bcf	CLK		;  
	goto	$+.1
	goto	$+.1
	incf	FSR,F		;  
	movf	FSR,W		;    
	xorlw	IBUF+.10
	btfss	STATUS,Z
	goto	z00
	bcf	DAT
	return

;  BIN-BCD.
;     BYTE_0 - BYTE_3.
BinBcd:	bcf	STATUS,C
	movlw	.32
	movwf	COUNT
	clrf	BCD0
	clrf	BCD1
	clrf	BCD2
	clrf	BCD3
	clrf	BCD4
	clrf	BCD5
loop32:	rlf	BYTE0,F
	rlf	BYTE1,F
	rlf	BYTE2,F
	rlf	BYTE3,F
	rlf	BCD5,F
	rlf	BCD4,F
	rlf	BCD3,F
	rlf	BCD2,F
	rlf	BCD1,F
	rlf	BCD0,F
	decfsz	COUNT,F
	goto	adjDEC
	return
adjDEC:	movlw	BCD5
	movwf	FSR
	call	adjBCD
	movlw	BCD4
	movwf	FSR
	call	adjBCD
	movlw	BCD3
	movwf	FSR
	call	adjBCD
	movlw	BCD2
	movwf	FSR
	call	adjBCD
	movlw	BCD1
	movwf	FSR
	call	adjBCD
	movlw	BCD0
	movwf	FSR
	call	adjBCD
	goto	loop32
adjBCD:	movlw	0x03
	addwf	INDF,W
	movwf	TEMP
	btfsc	TEMP,3
	movwf	INDF
	movlw	0x30
	addwf	INDF,W
	movwf	TEMP
	btfsc	TEMP,7
	movwf	INDF
	return

;  0.999ms(Ft=4MHz).
Dly1:	movlw	.99
	movwf	CNT1
	goto	$+.1
	goto	$+.1
	goto	$+.1
	goto	$+.1
	goto	$+.1
	nop
	decfsz	CNT1,F
	goto	$-5
	return

;  99.999ms(Ft=4MHz).
Dly100:	movlw	.99
	movwf	CNT2
	call	Dly1
	decfsz	CNT2,F
	goto	$-.2
	movlw	.198
	movwf	CNT2
	nop
	decfsz	CNT2,F
	goto	$-.2
	goto	$+.1
	nop
	return

	end

